###########################################################################
#
# docproc.pm --
# A component of the Greenstone digital library software
# from the New Zealand Digital Library Project at the 
# University of Waikato, New Zealand.
#
# Copyright (C) 1999 New Zealand Digital Library Project
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
###########################################################################

# document processors are used by the document reader plugins
# to do some processing on some documents

package docproc;

sub new {
    my ($class) = @_;
    my $self = {};

    $self->{'OIDtype'} = "hash";

    return bless $self, $class;
}

sub process {
    my $self = shift (@_);
    my ($doc_obj) = @_;

    die "docproc::process function must be implemented in sub classes\n";
}

# OIDtype may be "hash" or "incremental"
sub set_OIDtype {
    my $self = shift (@_);
    my ($type) = @_;

    if ($type eq "incremental") {
	$self->{'OIDtype'} = $type;
    } else {
	$self->{'OIDtype'} = "hash";
    }
}

sub set_saveas {
    my $self = shift (@_);
    my ($saveas) = @_;

    $self->{'saveas'} = $saveas;

}


1;







